\chapter{Conclusions\label{sec:conclusions}}

%% 1 Page. Not more.

In this thesis I have presented how the CHABADA technique works and what modifications I have implemented in order to make it scalable enough for running it against the Tacyt dataset. The size of my final dataset was around 700000 applications. This size was large enough to make the pipeline crash in some places and degrade the performance in some others. The changes I have introduced have allowed me to run all of the pipeline with the dataset.

The changes introduced in the implementation have allowed me to run the whole dataset in a reasonable time. This changes involved the usage of a database backend designed for speed, MongoDB, and the reimplementation of the code with scalability in mind. The support for scalability of Luigi is not the most advanced of the world, but is good enough for my purposes.

\section{Future work}

As always, there is room for improvement and this section discuses some possibilities.

The limit of 16MB of transference in PyMongo is more of a annoyance than a bug. It is possible to implement the code so that this problem is avoided. There are two possible solutions to the problem. The first one is to change the Mongo library used. This library needs to be compatible with the MongoDB Luigi modules or those would need to be rewritten too. Of course, this modification is useless if this hardcoded limits or other are present in the alternative libraries. The second option is to change the backend to another database. Not all databases can fit with the schema of the data, but other document oriented databases could be used. One example is Elasticsearch\cite{Elastics67:online}. Elasticsearch can be used as a data lake thanks to its powerful internal search engine, Apache Lucene. As far as I know, Elasticsearch does not have limits in the document size or in the transference of data between clients and servers. It also is very easily scalable thanks to its architecture. The main thing to think about is if the advantages of changing the library or the whole database backend is worth enough the effort. As mentioned, is not a bug, but a limit that can be avoided with proper load balancing.

The second situation is that since the Mallet module has not been changed, there's still need to write the files that the mallet tool uses as input. This problem can be addressed in two ways too. The first one is to write a Java wrapper that connects to mallet as a library and performs all the operations in memory. This wrapper will connect to the database backend and extract the data directly from there. Other option is to change the implementation of LDA to a Python based implementation. There are two options that can be used given the size of the problem. The first one is the library called Gensim\cite{gensim}. This library implements LDA and has implemented a master slave architecture where dumb workers can parallelize the execution of the algorithms. The other possibility is similar, in PySpark there's an implementation of LDA\cite{pyspark_lda} and has the same parallelization capabilities than Gensim. If more parts of the code is modified to run in Spark workers, then the PySpark option is the most interesting one since the tasks can share worker instances of Spark. Other than that, there are not strong arguments against one or the other.

% Old
%% The main concern that the explained implementation has in this thesis is the Out Of Memory bugs that the silhouette calculation causes. This problem can only be avoided by changing the implementation of the silhouete. Probably, the most successful solution to this problem is to use a distributed implementation of the silhouette. Since the silhouette needs to make a lot of matrix operations, a good matrix library will be needed. Probably the most interesting option would be to use a Spark based implementation that is designed to be scalable without speed concerns. The RDD abstraction in Spark will surely provide a good starting point for making the calculations needed for the silhouette in an scalable fashion.

Other interesting path to explore is the graph that I obtained from scrapping the Google Play Store. I do believe that from this graph more information can be obtained and could be used to reason about applications in the store, and serve as a Ground Truth when processing applications in some kind of manner, like the machine learning algorithms used in this work. The scoring system can surely use some improvements, but is nonetheless promising.

From the results of the anomaly detection I obtained that being classified as an outlier is not correlated to being malware detected by the store and then removed. Other possibility is that the application is abandonware. Possible ways for checking this is looking at the activity by the developer. If the developer hasn't update the application in a very long time (from the scraped results in Tacyt, for example) or the developer is nowhere to be found in the store, that's an strong indicator that the application is abandoned and Google removed it after the license expired.
